#include "globals.h"


/********************************************************************************
 *																				*
 *	     									*
 *																				*
 ********************************************************************************/

LRESULT CALLBACK MainWindowProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{

	case WM_DESTROY: /*   */
		ClearTrash();
		PostQuitMessage (0);
		break;

	case WM_SETFOCUS: /*    */
		UpdateWnd(); 
	
	case WM_COMMAND: /*    */
            switch(wParam)
			{

			case IDM_OPEN:   // 
              {if(!GetOpenFileName ((LPOPENFILENAME)&ofn)) break; ReadFile(ofn.lpstrFile); }
			  break;

			case IDM_SAVE:   // 
              {if(!GetSaveFileName ((LPOPENFILENAME)&ofn)) break; SaveFile(ofn.lpstrFile); }
			  break;
			
			case IDM_ABOUT:   //  
              DialogBox(
                        hInstance,                   
                        MAKEINTRESOURCE(IDD_ABOUT),   
                        hWnd,                        
                        AboutDlg);
			  break;
             
            case IDM_EXIT: /*   */
              ClearTrash();
	          PostQuitMessage (0);
	          break;
			}
			break;

	case WM_LBUTTONDOWN:
			xPos = LOWORD(lParam);  
			yPos = HIWORD(lParam);
			CurMapFile.Map[((xPos-3)/BLOCKSZ + ((yPos+1)/BLOCKSZ)*BWIDTH)]=1;
			break;

	case WM_RBUTTONDOWN:
			xPos = LOWORD(lParam);  
			yPos = HIWORD(lParam);
			CurMapFile.Map[((xPos-3)/BLOCKSZ + ((yPos+1)/BLOCKSZ)*BWIDTH)]=0;
			break;

	case WM_MOUSEMOVE:
			Key = wParam;
			xPos = LOWORD(lParam);  
			yPos = HIWORD(lParam);
			switch(Key)
			{
				case MK_LBUTTON: 
				CurMapFile.Map[((xPos-3)/BLOCKSZ + ((yPos+1)/BLOCKSZ)*BWIDTH)]=1;
				break;

				case MK_RBUTTON: 
				CurMapFile.Map[((xPos-3)/BLOCKSZ + ((yPos+1)/BLOCKSZ)*BWIDTH)]=0;
				break;
			}
	
	case WM_PAINT:UpdateWnd();
	default:
	//   ,      .
	//     Windows    
	return DefWindowProc (hWnd, message, wParam, lParam);
}
return 0;
}



/********************************************************************************
 *																				*
 *	Main - 																*
 *																				*
 ********************************************************************************/

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpszCmdLine, int nCmdShow)
{
	MSG lpMsg;
	WNDCLASSEX wcl;

	ofn.lStructSize       = sizeof(OPENFILENAME);
	ofn.hwndOwner	  = hWnd;
    ofn.lpstrFilter	  = " (*.lev)\0*.lev\0";
    ofn.lpstrCustomFilter = NULL;
    ofn.nMaxCustFilter	  = 0;
    ofn.nFilterIndex	  = 1;
    ofn.lpstrFile         = FName;
    ofn.nMaxFile		  = MAXFILENAME;
    ofn.lpstrInitialDir   = NULL;
    ofn.lpstrFileTitle    = FTitle;
    ofn.nMaxFileTitle     = MAXFILENAME;
    ofn.lpstrTitle        = NULL;
    ofn.lpstrDefExt       = "LEV";
    ofn.Flags             = 0;

/*    */

wcl.cbSize = sizeof (wcl);	                     //  WNDCLASSEXA
wcl.style = CS_VREDRAW | CS_HREDRAW;			 //  
wcl.lpfnWndProc = MainWindowProc;	             //  
wcl.cbClsExtra  =0;	                             //   Windows
wcl.cbWndExtra  = 0; 	                         //   Windows
wcl.hInstance = hInst;	                         //  
wcl.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_APP)); //  
wcl.hCursor = LoadCursorA(NULL,IDC_ARROW);	     // 
//     
wcl.hbrBackground =(HBRUSH) GetStockObject(BLACK_BRUSH); 
wcl.lpszMenuName = MAKEINTRESOURCE(IDM_MAIN);	 // 
wcl.lpszClassName = NAME;          	             //  
wcl.hIconSm=NULL;	                             //  ,    

hInstance = hInst;                               //    
                                                 //
// 
SetTimer(hWnd, TIMER_ID,  TIMER_RATE,  (TIMERPROC)TimerProc);

//  
if (!RegisterClassEx (&wcl))
return 0;
//       hWnd
hWnd=CreateWindowEx(
	0,		                                     //  
	NAME,       								 //
	TITLE,		                     			 //
	WS_FIXEDWINDOW,         	                 // 
	CW_USEDEFAULT,	                             //X- .   
	CW_USEDEFAULT,                             	 //Y- .   
	BWIDTH*BLOCKSZ+7,                            // 
	BHEIGHT*BLOCKSZ+53+YOFFS,                    // 
	NULL,	                                     //  
	NULL,	                                     //  
	hInst,	                                     //.   
	NULL);	                                     //    


//  
if (!Init())
   {
    MessageBox(hWnd,"   .   ","",16);
    ClearTrash();
	PostQuitMessage (0);
   }

//    
ShowWindow (hWnd, nCmdShow);
UpdateWnd();
/*     */
while (GetMessage(&lpMsg,NULL,0,0))
{
	TranslateMessage(&lpMsg);	//  
	DispatchMessage(&lpMsg);	//  Windows
}
	return lpMsg.wParam;
}	// WinMain



/********************************************************************************
 *																				*
 *	 													*
 *																				*
 ********************************************************************************/

bool Init(void)
{
	
	//    . 
	hDC=GetDC(hWnd);
	
	if (!hDC) return false;
	
	if (!LoadBitmapToDC(hStoneDC, IDB_STONE)) return false;

	if (!LoadBitmapToDC(hBodyDC[0], IDB_1)) return false;
	if (!LoadBitmapToDC(hBodyDC[1], IDB_2)) return false;
	if (!LoadBitmapToDC(hBodyDC[2], IDB_3)) return false;
	if (!LoadBitmapToDC(hBodyDC[3], IDB_4)) return false;

	return true;
}



/****************************************************************************
 *																			*
 *	   											*
 *	  ,    					*
 *																			*
 ****************************************************************************/

void CALLBACK TimerProc(HWND hWnd, UINT uMsg, UINT idEvent, DWORD dwTime)
{
	UpdateWnd();
}




/********************************************************************************
 *																				*
 *	 																*
 *																				*
 ********************************************************************************/

void UpdateWnd(void)
{	
	
	ShowMap();
		
}



/********************************************************************************
 *																				*
 *	  														*
 *																				*
 ********************************************************************************/

void ClearTrash(void)
{
	
	ReleaseDC(hWnd, hDC);
	ReleaseDC(hWnd, hStoneDC);

	for(int cnt=0; cnt<=3; cnt++) ReleaseDC(hWnd, hBodyDC[cnt]);
}



/********************************************************************************
 *																				*
 *	 																*							
 *																				* 
 ********************************************************************************/

void ShowMap(void)
{

for (int y=0; y<BHEIGHT;y++)
	{
	for (int x=0; x<BWIDTH;x++)
		{

			switch (CurMapFile.Map[x+y*BWIDTH])
			{
			case 0:
				{
				SelectObject(hDC, GetStockObject(BLACK_BRUSH)); 
				Rectangle(hDC,x*BLOCKSZ+XOFFS,y*BLOCKSZ+YOFFS,
				(x*BLOCKSZ)+BLOCKSZ+XOFFS,(y*BLOCKSZ)+BLOCKSZ+YOFFS);
				}
				break;
			case 1:
				{
				BitBlt(hDC,x*BLOCKSZ+XOFFS,y*BLOCKSZ+YOFFS,
				BLOCKSZ, BLOCKSZ,hStoneDC,0,0,SRCCOPY);
				}
				break;
			}
		}
	}
}





