#include "globals.h"


/********************************************************************************
 *																				*
 *	     									*
 *																				*
 ********************************************************************************/

LRESULT CALLBACK MainWindowProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{

	case WM_DESTROY: /*   */
		ClearTrash();
		PostQuitMessage (0);
		break;

	case WM_KILLFOCUS: /*    */
		Active=false; 
		break;

	case WM_SETFOCUS: /*    */
		UpdateWnd();
		break;
	
	case WM_COMMAND: /*    */
            switch(wParam)
			{
			case IDM_NEWGAME: //  
			  EraseSnake();
              InitSnake();
			  Active=false;
			  ShowSnake(NORMAL);
			  break;
			case IDM_ABOUT:   //  
              DialogBox(
                        hInstance,                   
                        MAKEINTRESOURCE(IDD_ABOUT),   
                        hWnd,                        
                        AboutDlg);
			  break;
            case IDM_LEVEL:   // 
              OldLevel=Level;
              DialogBox(
                        hInstance,                   
                        MAKEINTRESOURCE(IDD_LEVEL),   
                        hWnd,                        
                        LevelDlg);
			  if(Level!=OldLevel)
				{
					EraseSnake();
					InitSnake();
					Active=false;
					UpdateWnd();
				}
			  Delay=Time[Level];
			  break; 
            case IDM_OPTIONS: // 
              OldWalls=Walls;
              DialogBox(
                        hInstance,                   
                        MAKEINTRESOURCE(IDD_OPTIONS),   
                        hWnd,                        
                        OptionsDlg);
			  if(Walls!=OldWalls)
				{
					EraseSnake();
					InitSnake();
					Active=false;
					UpdateWnd();
				}
			  break;  
		    case IDM_EXIT: /*   */
              ClearTrash();
	          PostQuitMessage (0);
	          break;
			}
			break;
	case WM_PAINT:
		UpdateWnd();
	
	default:
	//   ,      .
	//     Windows    
	return DefWindowProc (hWnd, message, wParam, lParam);
}
return 0;
}



/********************************************************************************
 *																				*
 *	Main - 																*
 *																				*
 ********************************************************************************/

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpszCmdLine, int nCmdShow)
{
	MSG lpMsg;
	WNDCLASSEX wcl;

/*    */

wcl.cbSize = sizeof (wcl);	                     //  WNDCLASSEXA
wcl.style = CS_VREDRAW | CS_HREDRAW;			 //  
wcl.lpfnWndProc = MainWindowProc;	             //  
wcl.cbClsExtra  =0;	                             //   Windows
wcl.cbWndExtra  = 0; 	                         //   Windows
wcl.hInstance = hInst;	                         //  
wcl.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_APP)); //  
wcl.hCursor = LoadCursorA(NULL,IDC_ARROW);	     // 
//     
wcl.hbrBackground =(HBRUSH) GetStockObject(BLACK_BRUSH); 
wcl.lpszMenuName = MAKEINTRESOURCE(IDM_MAIN);	 // 
wcl.lpszClassName = NAME;          	             //  
wcl.hIconSm=NULL;	                             //  ,    

hInstance = hInst;                               //    
                                                 //

//  
if (!RegisterClassEx (&wcl))
return 0;
//       hWnd
hWnd=CreateWindowEx(
	0,		                                     //  
	NAME,       								 //
	TITLE,		                     			 //
	WS_FIXEDWINDOW,         	                 // 
	CW_USEDEFAULT,	                             //X- .   
	CW_USEDEFAULT,                             	 //Y- .   
	BWIDTH*BLOCKSZ+7,                            // 
	BHEIGHT*BLOCKSZ+53+YOFFS,                    // 
	NULL,	                                     //  
	NULL,	                                     //  
	hInst,	                                     //.   
	NULL);	                                     //    

// 
SetTimer(hWnd, TIMER_ID,  TIMER_RATE,  (TIMERPROC)TimerProc);

//    
ShowWindow (hWnd, nCmdShow);
UpdateWnd();

//  
if (!Init())
   {
    MessageBox(hWnd,"   .   ","",16);
    ClearTrash();
	PostQuitMessage (0);
   }


/*     */
while (GetMessage(&lpMsg,NULL,0,0))
{
	TranslateMessage(&lpMsg);	//  
	DispatchMessage(&lpMsg);	//  Windows
}
	return lpMsg.wParam;
}	// WinMain



/********************************************************************************
 *																				*
 *	 													*
 *																				*
 ********************************************************************************/

bool Init(void)
{
	
	hFont=CreateFont(16,8,0,0,700,false,false,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,
					   CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH||FF_MODERN,"Courier New");
	
	if (!ReadData())
		{
		Level=1;
		Walls=true;
		}
	Delay=Time[Level];

	srand(time(0));

	if (!ReadFile("level1.lev")) return false;

	NmOfStones=0;

	for (int cnt=0; cnt<BWIDTH*BHEIGHT; cnt++)
		if (CurMapFile.Map[cnt]==1) NmOfStones++;

	//       DirectInput

	if (!DI_Init())	return false;


	//    . 
	hDC=GetDC(hWnd);
	
	if (!hDC) return false;
	
	if (!LoadBitmapToDC(hAppleDC, IDB_APPLE)) return false;

	if (!LoadBitmapToDC(hStoneDC, IDB_STONE)) return false;

	if (!LoadBitmapToDC(hBodyDC[0], IDB_HEAD_U)) return false;
	if (!LoadBitmapToDC(hBodyDC[1], IDB_HEAD_D)) return false;
	if (!LoadBitmapToDC(hBodyDC[2], IDB_HEAD_L)) return false;
	if (!LoadBitmapToDC(hBodyDC[3], IDB_HEAD_R)) return false;

	if (!LoadBitmapToDC(hBodyDC[4], IDB_NECK_H)) return false;
	if (!LoadBitmapToDC(hBodyDC[5], IDB_NECK_V)) return false;
	if (!LoadBitmapToDC(hBodyDC[6], IDB_NECK_UL)) return false;
	if (!LoadBitmapToDC(hBodyDC[7], IDB_NECK_UR)) return false;
	if (!LoadBitmapToDC(hBodyDC[8], IDB_NECK_DL)) return false;
	if (!LoadBitmapToDC(hBodyDC[9], IDB_NECK_DR)) return false;
	
	if (!LoadBitmapToDC(hBodyDC[10], IDB_TAIL_U)) return false;
	if (!LoadBitmapToDC(hBodyDC[11], IDB_TAIL_D)) return false;
	if (!LoadBitmapToDC(hBodyDC[12], IDB_TAIL_L)) return false;
	if (!LoadBitmapToDC(hBodyDC[13], IDB_TAIL_R)) return false;

	if (!LoadBitmapToDC(hTopDC, IDB_TOP)) return false;
	
	InitSnake(); //  

	NewApple();	 //  

	Active=false; 

	for (int y=0; y<BHEIGHT;y++)
	{
	for (int x=0; x<BWIDTH;x++)
		{

			switch (CurMapFile.Map[x+y*BWIDTH])
			{
			case 0:
				{
				SelectObject(hDC, GetStockObject(BLACK_BRUSH)); 
				Rectangle(hDC,x*BLOCKSZ+XOFFS,y*BLOCKSZ+YOFFS,
				(x*BLOCKSZ)+BLOCKSZ+XOFFS,(y*BLOCKSZ)+BLOCKSZ+YOFFS);
				}
				break;
			case 1:
				{
				BitBlt(hDC,x*BLOCKSZ+XOFFS,y*BLOCKSZ+YOFFS,
				BLOCKSZ, BLOCKSZ,hStoneDC,0,0,SRCCOPY);
				}
				break;
			}
		}
	}

	return true;
}



/****************************************************************************
 *																			*
 *	   											*
 *	  ,    					*
 *																			*
 ****************************************************************************/

void CALLBACK TimerProc(HWND hWnd, UINT uMsg, UINT idEvent, DWORD dwTime)
{
	for (int cnt=0; cnt<256; cnt++) buffer[cnt] =0;
	
	HRESULT hr;
	if(FAILED(g_lpDIDevice->GetDeviceState(sizeof(buffer),(LPVOID)&buffer)))
		{
		hr=g_lpDIDevice->Acquire();
		while( hr == DIERR_INPUTLOST )
			hr=g_lpDIDevice->Acquire();
		return;
		}

	for (cnt=0; cnt<256; cnt++) if (KEYDOWN(buffer, cnt)&&(!Active)) Active=true; 

	if (KEYDOWN(buffer, DIK_RIGHT)) {if (!Horizontal()) Dir=RIGHT;} 
    if (KEYDOWN(buffer, DIK_LEFT))  {if (!Horizontal()) Dir=LEFT;} 
	if (KEYDOWN(buffer, DIK_UP))    {if ( Horizontal()) Dir=UP;} 
	if (KEYDOWN(buffer, DIK_DOWN))  {if ( Horizontal()) Dir=DOWN;} 
	if (KEYDOWN(buffer, DIK_ESCAPE))  {Active=false;} 

	if (idEvent==TIMER_ID && Active) TickCount+=15;
	
	if (TickCount==Delay && Active)
	{

	 TickCount=0;

	 NextNeck=GetNextNeck();

	 MoveHead(); //  

	 
	 NextTail=GetNextTail();
	 
	 switch (Crashed())
		{
	 
		case true:
     
			ShowSnake(CRASHED);
			Active=false;
			MessageBox(hWnd," ...","...",48);
			EraseSnake();
			InitSnake();
			UpdateWnd();
			break;

		case false:	 
     
			//  
			EraseSnake();  

			//   
			for (int cnt=Length-1; cnt>=0; cnt--) Body[cnt+1]=Body[cnt];
	
			Body[0]=Head;

			//  ...
			if (AppleAte()) 
				{
				NewApple();
				Length++;
				Score+=(Level*3);
				}

			break;
		}
	
	 //  
	 UpdateWnd();

	}
}



/********************************************************************************
 *																				*
 *	 																*
 *																				*
 ********************************************************************************/

void UpdateWnd(void)
{	
	
	for (int x=0; x<128; x++)
	BitBlt(hDC,x*5,15,5,5,hTopDC,0,0,SRCCOPY);

	for (int y=0; y<BHEIGHT;y++)
	{
	for (int x=0; x<BWIDTH;x++)
		{

			switch (CurMapFile.Map[x+y*BWIDTH])
			{
			case 0:
				{
				SelectObject(hDC, GetStockObject(BLACK_BRUSH)); 
				Rectangle(hDC,x*BLOCKSZ+XOFFS,y*BLOCKSZ+YOFFS,
				(x*BLOCKSZ)+BLOCKSZ+XOFFS,(y*BLOCKSZ)+BLOCKSZ+YOFFS);
				}
				break;
			case 1:
				{
				BitBlt(hDC,x*BLOCKSZ+XOFFS,y*BLOCKSZ+YOFFS,
				BLOCKSZ, BLOCKSZ,hStoneDC,0,0,SRCCOPY);
				}
				break;
			}
		}
	}
	
	char sc[6];
	sprintf(sc,"%d %4",Score);
	SetBkColor(hDC,BLACK_BRUSH);
	SetTextColor(hDC,RGB(255,255,0));
	SelectObject(hDC, hFont);
	TextOut(hDC,20,0,sc,strlen(sc));
	ShowSnake(NORMAL);  // 
	ShowApple();        // 
}



/********************************************************************************
 *																				*
 *	  														*
 *																				*
 ********************************************************************************/

void ClearTrash(void)
{
	SaveData();

	ReleaseDC(hWnd, hDC);
	ReleaseDC(hWnd, hAppleDC);
	ReleaseDC(hWnd, hTopDC);
	ReleaseDC(hWnd, hStoneDC);
	DeleteObject(hFont); 

	for(int cnt=0; cnt<=13; cnt++) ReleaseDC(hWnd, hBodyDC[cnt]);

	DI_Term();
	
}








